/*
 * sys_thread_exit.c - terminates the execution of calling thread
 * 
 * Authors   Alain Greiner (2016,2017)
 *
 * Copyright (c) UPMC Sorbonne Universites
 *
 * This file is part of ALMOS-MKH.
 *
 * ALMOS-MKH is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.0 of the License.
 *
 * ALMOS-MKH is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ALMOS-MKH; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include <hal_types.h>
#include <thread.h>
#include <core.h>
#include <vmm.h>
#include <scheduler.h>
#include <printk.h>

////////////////////////////////////////
int sys_thread_exit( void * exit_value )
{
	thread_t  * this    = CURRENT_THREAD;
    process_t * process = this->process;

    // check exit_value argument
    if( exit_value != NULL )
    {

#if CONFIG_DEBUG_SYSCALLS_ERROR
printk("\n[ERROR] in %s : exit_value argument must be NULL for thread %x in process %x\n",
__FUNCTION__ , exit_value, this->trdid , process->pid );
#endif
        this->errno = EINVAL;
        return -1;
    }

#if CONFIG_DEBUG_SYS_THREAD_EXIT
uint64_t     tm_start;
uint64_t     tm_end;
tm_start = hal_get_cycles();
if( CONFIG_DEBUG_SYS_THREAD_EXIT < tm_start )
printk("\n[DBG] %s : thread %x enter / process %x / cycle %d\n",
__FUNCTION__ , this, process->pid , (uint32_t)tm_start );
#endif

    // cal the relevant kernel function
    thread_kill( XPTR( local_cxy , this ),
                 1,           // is_exit
                 0 );         // is forced

#if CONFIG_DEBUG_SYS_THREAD_EXIT
tm_end = hal_get_cycles();
if( CONFIG_DEBUG_SYS_THREAD_EXIT < tm_end )
printk("\n[DBG] %s : thread %x exit / process %x / cost %d / cycle %d\n",
__FUNCTION__, this, this->process->pid, (uint32_t)(tm_end - tm_start), (uint32_t)tm_end );
#endif

    // deschedule <=> suicide, because blocked by thread_kill()
    sched_yield( "suicide after thread_exit" );
    
    return 0;   // never executed but required by compiler

}  // end sys_thread exit
